import socket
import threading
import logging
import time 
import sys
from util import * 

message_queue=[]
if len(sys.argv) > 1 : 
    args = sys.argv[1:] 
    for arg in args : 
        message_queue.append("prog : " + arg)
else : 
    message_queue=["prog : echo hello"]

print(message_queue)

connections_threads=[] # active clients 
data_socks={}

HOST = "127.0.0.1"
PORT = 1235

data_port = input("Port data ?") ## port de donnée utilisé pour le premier utilisateur (ensuite incrémenté par 1) 
if data_port == "":  
    data_port = 43222
else :
    data_port = int(data_port) 

nb_connections = 0 
stop = 0 

s = socket.socket(socket.AF_INET, socket.SOCK_STREAM)

### SERVER THREADS 
class thread_get_input(threading.Thread): 
    def __init__(self) : 
        threading.Thread.__init__(self)
    def run(self) : 
        while True : 
            program = get_program_input() 
            if program != "" :  
                message_queue.append("prog : " + program) 
            if stop == 1 : 
                break 

class thread_command_execution(threading.Thread) : 
    def __init__(self) : 
        threading.Thread.__init__(self) 
        self.round_robin_inc = 0 
    def run(self) : 
        try : 
            while True : 
                if len(connections_threads) != 0 and len(message_queue) != 0 : 
                    index =  self.round_robin_inc % len(connections_threads) 
                    thread = connections_threads[index]
                    self.round_robin_inc = self.round_robin_inc + 1
                    program = message_queue.pop()
                    thread.command_program_execution(program)
                if stop == 1 : 
                    break
        except KeyboardInterrupt : 
            self.s_data.close() 
            raise 

class thread_handle_socket(threading.Thread): 
    def __init__(self) :
        threading.Thread.__init__(self)

        data_socks[data_port] = socket.socket(socket.AF_INET, socket.SOCK_STREAM)
        self.s_data = data_socks[data_port]
        self.s_data.bind(('', data_port))
        self.s_data.listen() 
        self.conn, self.addr = self.s_data.accept() 

    def command_program_execution(self, program):  
            self.conn.send(encode_message(program))
            start_time = time.time() 
            data = self.conn.recv(1024)
            end_time = time.time() 
            mtype, ret_val = get_message_type(decode_message(data)) 
            print("Received " + str(ret_val) + " from " + str(self.addr[0]) + " in %s seconds ", end_time - start_time ) 

    def run(self) :
        while True : 
            time.sleep(1) 
            if stop == 1 : 
                break 

## MAIN 

# starts thread that reads input from user 
thread_input  = thread_get_input() 
thread_input.start() 

thread_exec = thread_command_execution() 
thread_exec.start() 

s.bind(('', PORT))
s.listen()
try : 
    while True : 
        conn, addr = s.accept()
        print("Nouvelle machine connectée : " + addr[0]) 
        #send data port to connected host 
        message = "prt : "+ str(data_port)
        conn.sendall(encode_message(message)) 

        # opens a new thread, which will open a data socket
        connections_threads.append(thread_handle_socket())
        connections_threads[nb_connections].start()

        # increment it for the next one 
        data_port = data_port + 5;
        nb_connections = nb_connections + 1 

        conn.close() 

except KeyboardInterrupt : 
    s.close() 
    stop = 1 
    print("     Exiting...") 
    raise 
