import socket 
import threading 
import time 
import sys 
from util import * 

received_message_queue = [] 
dataport = 0 
PORT = 1235
stop = 0 

empty_inc = 0 #inc var counting number of empty packets received 

# server control socket
if len(sys.argv) > 1: 
    SERVER=sys.argv[1]
else : 
    SERVER = "127.0.0.1"
print("server address: " , SERVER);

### FUNCTIONS
def thread_execute_programs() : 
    while True :
        if len(received_message_queue) != 0 : 
            print("handling message in thread") 
            message = received_message_queue.pop() 
            handle_message(message) 
        if stop == 1 : 
            break 
        time.sleep(1) 

## MAIN CODE 
if __name__ == "__main__" :

    s =  socket.socket(socket.AF_INET, socket.SOCK_STREAM) 
    s.connect((SERVER, PORT)) # connection to server. Crashes if refused. 

    # first receives port and closes connection to control socket...
    data = s.recv(1024)
    dataport = get_data_port(data) 
    # close connection 
    s.shutdown(socket.SHUT_RDWR)
    s.close() 
    
    print("Trying to open connection to data socket... ") 
    # opens the new server socket 
    while True : 
        try : 
            
            s_data = socket.socket(socket.AF_INET, socket.SOCK_STREAM)
            s_data.connect((SERVER, dataport)) 
            break 
        except ConnectionRefusedError : 
            print("retrying...") 
            time.sleep(1) 

    thread_exec = threading.Thread(target = thread_execute_programs, args=() ) 
    thread_exec.start() 
 
    # then gets data 
    while True : 
        try : 
            print("Waiting for data from server...") 
            data = s_data.recv(1024)

            if len(data) == 0 : 
                empty_inc = empty_inc + 1 
            else : 
                empty_inc = 0 
            
            if empty_inc > 10 : 
                raise KeyboardInterrupt 

            message = decode_message(data) 
            ret_val = handle_message(message) 
            if ret_val is not None : 
                s_data.send(str.encode(ret_val))
            elif ret_val == "-1" : 
                print("Closing data socket...") 
                raise KeyboardInterrupt 

        except KeyboardInterrupt : 
            s_data.close() 
            stop = 1 
            print("    Exiting...") 
            raise 
